/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"

#if ENABLE(SHARED_WORKERS)

#include "JSSharedWorkerGlobalScope.h"

#include "EventListener.h"
#include "JSEventListener.h"
#include "SharedWorkerGlobalScope.h"
#include "URL.h"
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>

#if ENABLE(SHARED_WORKERS)
#include "JSSharedWorkerGlobalScope.h"
#endif

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSSharedWorkerGlobalScopeTableValues[] =
{
    { "name", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSharedWorkerGlobalScopeName), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "onconnect", DontDelete, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSharedWorkerGlobalScopeOnconnect), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSSharedWorkerGlobalScopeOnconnect) },
#if ENABLE(SHARED_WORKERS)
    { "SharedWorkerGlobalScope", DontEnum, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSharedWorkerGlobalScopeSharedWorkerGlobalScopeConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(setJSSharedWorkerGlobalScopeSharedWorkerGlobalScopeConstructor) },
#endif
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsSharedWorkerGlobalScopeConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSSharedWorkerGlobalScopeTable = { 9, 7, true, JSSharedWorkerGlobalScopeTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSSharedWorkerGlobalScopeConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSSharedWorkerGlobalScopeConstructorTable = { 1, 0, false, JSSharedWorkerGlobalScopeConstructorTableValues, 0 };
static const HashTable& getJSSharedWorkerGlobalScopeConstructorTable(VM& vm)
{
    return getHashTableForGlobalData(vm, JSSharedWorkerGlobalScopeConstructorTable);
}

const ClassInfo JSSharedWorkerGlobalScopeConstructor::s_info = { "SharedWorkerGlobalScopeConstructor", &Base::s_info, 0, getJSSharedWorkerGlobalScopeConstructorTable, CREATE_METHOD_TABLE(JSSharedWorkerGlobalScopeConstructor) };

JSSharedWorkerGlobalScopeConstructor::JSSharedWorkerGlobalScopeConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSSharedWorkerGlobalScopeConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, globalObject->prototype(), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

bool JSSharedWorkerGlobalScopeConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSSharedWorkerGlobalScopeConstructor, JSDOMWrapper>(exec, getJSSharedWorkerGlobalScopeConstructorTable(exec->vm()), jsCast<JSSharedWorkerGlobalScopeConstructor*>(object), propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSSharedWorkerGlobalScopePrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSSharedWorkerGlobalScopePrototypeTable = { 1, 0, false, JSSharedWorkerGlobalScopePrototypeTableValues, 0 };
static const HashTable& getJSSharedWorkerGlobalScopePrototypeTable(VM& vm)
{
    return getHashTableForGlobalData(vm, JSSharedWorkerGlobalScopePrototypeTable);
}

const ClassInfo JSSharedWorkerGlobalScopePrototype::s_info = { "SharedWorkerGlobalScopePrototype", &Base::s_info, 0, getJSSharedWorkerGlobalScopePrototypeTable, CREATE_METHOD_TABLE(JSSharedWorkerGlobalScopePrototype) };

static const HashTable& getJSSharedWorkerGlobalScopeTable(VM& vm)
{
    return getHashTableForGlobalData(vm, JSSharedWorkerGlobalScopeTable);
}

const ClassInfo JSSharedWorkerGlobalScope::s_info = { "SharedWorkerGlobalScope", &Base::s_info, 0, getJSSharedWorkerGlobalScopeTable , CREATE_METHOD_TABLE(JSSharedWorkerGlobalScope) };

JSSharedWorkerGlobalScope::JSSharedWorkerGlobalScope(VM& vm, Structure* structure, PassRefPtr<SharedWorkerGlobalScope> impl)
    : JSWorkerGlobalScope(vm, structure, impl)
{
}

bool JSSharedWorkerGlobalScope::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSSharedWorkerGlobalScope* thisObject = jsCast<JSSharedWorkerGlobalScope*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSSharedWorkerGlobalScope, Base>(exec, getJSSharedWorkerGlobalScopeTable(exec->vm()), thisObject, propertyName, slot);
}

EncodedJSValue jsSharedWorkerGlobalScopeName(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSSharedWorkerGlobalScope* castedThis = jsDynamicCast<JSSharedWorkerGlobalScope*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    SharedWorkerGlobalScope& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.name());
    return JSValue::encode(result);
}


EncodedJSValue jsSharedWorkerGlobalScopeOnconnect(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSSharedWorkerGlobalScope* castedThis = jsDynamicCast<JSSharedWorkerGlobalScope*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    SharedWorkerGlobalScope& impl = castedThis->impl();
    if (EventListener* listener = impl.onconnect()) {
        if (const JSEventListener* jsListener = JSEventListener::cast(listener)) {
            if (JSObject* jsFunction = jsListener->jsFunction(&impl))
                return JSValue::encode(jsFunction);
        }
    }
    return JSValue::encode(jsNull());
}


#if ENABLE(SHARED_WORKERS)
EncodedJSValue jsSharedWorkerGlobalScopeSharedWorkerGlobalScopeConstructor(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSSharedWorkerGlobalScope* castedThis = jsDynamicCast<JSSharedWorkerGlobalScope*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    return JSValue::encode(JSSharedWorkerGlobalScope::getConstructor(exec->vm(), castedThis->globalObject()));
}

#endif

EncodedJSValue jsSharedWorkerGlobalScopeConstructor(ExecState* exec, EncodedJSValue thisValue, EncodedJSValue, PropertyName)
{
    JSSharedWorkerGlobalScope* domObject = jsDynamicCast<JSSharedWorkerGlobalScope*>(JSValue::decode(thisValue));
    if (!domObject)
        return throwVMTypeError(exec);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSSharedWorkerGlobalScope::getConstructor(exec->vm(), domObject->globalObject()));
}

void setJSSharedWorkerGlobalScopeOnconnect(ExecState* exec, JSObject* /* baseObject */, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    JSValue value = JSValue::decode(encodedValue);
    UNUSED_PARAM(exec);
    JSSharedWorkerGlobalScope* castedThis = jsDynamicCast<JSSharedWorkerGlobalScope*>(JSValue::decode(thisValue));
    if (!castedThis) {
        throwVMTypeError(exec);
        return;
    }
    UNUSED_PARAM(exec);
    SharedWorkerGlobalScope& impl = castedThis->impl();
    impl.setOnconnect(createJSAttributeEventListener(exec, value, castedThis));
}


#if ENABLE(SHARED_WORKERS)
void setJSSharedWorkerGlobalScopeSharedWorkerGlobalScopeConstructor(ExecState* exec, JSObject* /* baseObject */, EncodedJSValue thisValue, EncodedJSValue encodedValue)
{
    JSValue value = JSValue::decode(encodedValue);
    UNUSED_PARAM(exec);
    JSSharedWorkerGlobalScope* castedThis = jsDynamicCast<JSSharedWorkerGlobalScope*>(JSValue::decode(thisValue));
    if (!castedThis) {
        throwVMTypeError(exec);
        return;
    }
    // Shadowing a built-in constructor
    castedThis->putDirect(exec->vm(), Identifier(exec, "SharedWorkerGlobalScope"), value);
}

#endif

JSValue JSSharedWorkerGlobalScope::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSSharedWorkerGlobalScopeConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}

SharedWorkerGlobalScope* toSharedWorkerGlobalScope(JSC::JSValue value)
{
    return value.inherits(JSSharedWorkerGlobalScope::info()) ? &jsCast<JSSharedWorkerGlobalScope*>(value)->impl() : 0;
}

}

#endif // ENABLE(SHARED_WORKERS)
