/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "WebKitDOMProcessingInstruction.h"

#include "CSSImportRule.h"
#include "DOMObjectCache.h"
#include "Document.h"
#include "ExceptionCode.h"
#include "JSMainThreadExecState.h"
#include "WebKitDOMNodePrivate.h"
#include "WebKitDOMPrivate.h"
#include "WebKitDOMProcessingInstructionPrivate.h"
#include "WebKitDOMStyleSheetPrivate.h"
#include "gobject/ConvertToUTF8String.h"
#include <wtf/GetPtr.h>
#include <wtf/RefPtr.h>

namespace WebKit {

WebKitDOMProcessingInstruction* kit(WebCore::ProcessingInstruction* obj)
{
    return WEBKIT_DOM_PROCESSING_INSTRUCTION(kit(static_cast<WebCore::Node*>(obj)));
}

WebCore::ProcessingInstruction* core(WebKitDOMProcessingInstruction* request)
{
    return request ? static_cast<WebCore::ProcessingInstruction*>(WEBKIT_DOM_OBJECT(request)->coreObject) : 0;
}

WebKitDOMProcessingInstruction* wrapProcessingInstruction(WebCore::ProcessingInstruction* coreObject)
{
    ASSERT(coreObject);
    return WEBKIT_DOM_PROCESSING_INSTRUCTION(g_object_new(WEBKIT_TYPE_DOM_PROCESSING_INSTRUCTION, "core-object", coreObject, NULL));
}

} // namespace WebKit

G_DEFINE_TYPE(WebKitDOMProcessingInstruction, webkit_dom_processing_instruction, WEBKIT_TYPE_DOM_CHARACTER_DATA)

enum {
    PROP_0,
    PROP_TARGET,
    PROP_SHEET,
};

static void webkit_dom_processing_instruction_get_property(GObject* object, guint propertyId, GValue* value, GParamSpec* pspec)
{
    WebCore::JSMainThreadNullState state;

    WebKitDOMProcessingInstruction* self = WEBKIT_DOM_PROCESSING_INSTRUCTION(object);
    WebCore::ProcessingInstruction* coreSelf = WebKit::core(self);

    switch (propertyId) {
    case PROP_TARGET: {
        g_value_take_string(value, convertToUTF8String(coreSelf->target()));
        break;
    }
    case PROP_SHEET: {
        RefPtr<WebCore::StyleSheet> ptr = coreSelf->sheet();
        g_value_set_object(value, WebKit::kit(ptr.get()));
        break;
    }
    default:
        G_OBJECT_WARN_INVALID_PROPERTY_ID(object, propertyId, pspec);
        break;
    }
}

static void webkit_dom_processing_instruction_class_init(WebKitDOMProcessingInstructionClass* requestClass)
{
    GObjectClass* gobjectClass = G_OBJECT_CLASS(requestClass);
    gobjectClass->get_property = webkit_dom_processing_instruction_get_property;

    g_object_class_install_property(
        gobjectClass,
        PROP_TARGET,
        g_param_spec_string(
            "target",
            "ProcessingInstruction:target",
            "read-only gchar* ProcessingInstruction:target",
            "",
            WEBKIT_PARAM_READABLE));

    g_object_class_install_property(
        gobjectClass,
        PROP_SHEET,
        g_param_spec_object(
            "sheet",
            "ProcessingInstruction:sheet",
            "read-only WebKitDOMStyleSheet* ProcessingInstruction:sheet",
            WEBKIT_TYPE_DOM_STYLE_SHEET,
            WEBKIT_PARAM_READABLE));

}

static void webkit_dom_processing_instruction_init(WebKitDOMProcessingInstruction* request)
{
}

gchar* webkit_dom_processing_instruction_get_target(WebKitDOMProcessingInstruction* self)
{
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_PROCESSING_INSTRUCTION(self), 0);
    WebCore::ProcessingInstruction* item = WebKit::core(self);
    gchar* result = convertToUTF8String(item->target());
    return result;
}

WebKitDOMStyleSheet* webkit_dom_processing_instruction_get_sheet(WebKitDOMProcessingInstruction* self)
{
    WebCore::JSMainThreadNullState state;
    g_return_val_if_fail(WEBKIT_DOM_IS_PROCESSING_INSTRUCTION(self), 0);
    WebCore::ProcessingInstruction* item = WebKit::core(self);
    RefPtr<WebCore::StyleSheet> gobjectResult = WTF::getPtr(item->sheet());
    return WebKit::kit(gobjectResult.get());
}

